CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000

        CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
        MS_001   = CLK_FREQ / 1_00

        RX  = 31                                                     ' programming / terminal
        TX  = 30

        strippin = 25                                                     ' LED tx pin
        stripchan = 3
        ledcount = 128           

        dmxpin = 27
        dmxledpin = 0
        DMX_START_byte = 0                                                 ' monitor channels 1 - 6
        defaultdata = 0  

OBJ
  serial  : "my_PBnJ_serial"
  strip : "jm_ws2812"           ' WS2812 LED driver
  dmx   : "jm_dmxin"
  ''dmx   : "jm_dmxin-timestamp"

var
  long  stack1[16]

  long  dmxaddr
  long  ws2812addr    

pub main | i, j, k
  serial.Start(RX,TX,115_200)
  strip.start(strippin, ledcount)                                          ' start led driver
  ws2812addr:=strip.address
  dmx.init(dmxpin, dmxledpin, DMX_START_byte, defaultdata)
''  dmx.init(dmxpin, dmxledpin, DMX_START_byte, defaultdata,ws2812addr)
  dmxaddr:=dmx.address
''  cognew(convert,@stack1)
''  pause(10)

  repeat
    ''repeat i from 0 to ledcount-1      
      ''strip.set_rgb(i,dmx.read(i*stripchan+1),dmx.read(i*stripchan+2),dmx.read(i*stripchan+3))
    j:=cnt
    convert
    ''repeat i from 0 to ledcount-1      
    ''  strip.set_rgb(i,dmx.read(i*stripchan+1),dmx.read(i*stripchan+2),dmx.read(i*stripchan+3))
    j:=cnt-j
    if j <> k
      k:=j
      serial.dec(k)
      serial.tx(13)
{
    serial.hex(long[dmxaddr][0],8)
    serial.tx(13)
    serial.hex(long[ws2812addr][0],8)
    serial.tx(13)
    serial.tx(13)
}
pub convert|j
''repeat
  repeat j from 0 to ledcount-1
    long[ws2812addr][j]:=byte[dmxaddr][j*stripchan+1]<<16 + byte[dmxaddr][j*stripchan+2]<<8+byte[dmxaddr][j*stripchan+3]

pub pause(ms) | t

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)
    waitcnt(t += MS_001)
        